{$IFOPT O-}{$DEFINE NOOVR}{$ENDIF}

{
  *.S3M outlines of Nintendo music files
}

{ Created in <=2000 - Copyright (C) Joel Yliluoma }


{$O-,N+,E+}
{$I-,R-,S-,Q-}
{$M 8192,0,0}

{
	Compiler options:
		N+
		X+
		D LYHYT
		D USEDOSMEM
}

{$IFNDEF USEDOSMEM}
 {$ERROR USEDOSMEM NOT DEFINED??}
{$ENDIF}

Program NES_Music_OutLine;

Uses {$IFNDEF NOOVR}NesMusa3,Overlay,{$ENDIF}
		Crt,Strings,NesMusa1,NesMusa2,{$IFNDEF PLAYERONLY}NesMusa4,
		NesMusa5, {$ENDIF}WinDos,DosMem, {Mouse,}SetJmp;

{$IFNDEF NOOVR}
 {$O NESMUSA1}
 { $O NESMUSA4 -- code segment too large}
 {$O NESMUSA5}
 {$O SVGA}
 { $O DOSMEM}
 { $O STRINGS}
 { $O WINDOS}
 { $O SVGA}
{$ENDIF}

Var
  OldExit: Procedure;
  OldIMR: Byte;

Var
{$IFNDEF DPMI}
  SavedMCB: Array[0..1]Of Record a,b,c:Byte;w:Word;d,e,f, g,h,i,j,k,l,m,n: Byte End;
  SavedINT: Array[0..15]Of LongInt;
{$ENDIF}

Procedure SafeExit; Far;
Begin
  ExitProc := OldExit;
  Port[$21] := OldIMR;
  {$IFNDEF DPMI}
  Move(SavedMCB[0], Mem[PrefixSeg-1:0], 16);
  Move(SavedMCB[1], Mem[SavedMCB[0].w+PrefixSeg:0], 16);
  Move(SavedINT, Mem[0:0], SizeOf(SavedInt))
  {$ENDIF}
End;

Function HeapFunc(Size: Word): Integer; Far;
Begin
  Write('*** NESMusa can''t allocate ',LongInt(Size) * 16,
        #13^J'*** bytes of memory for ', LastAlloc);
  Error('.')
End;

Type RunnerProc = Procedure;

Procedure Runner; Far;
Begin
(*If(@Player = @Show1)Then ShowMouse;*)
	{$IFNDEF PLAYERONLY}
	If(@Player <> @Converter)Then
	Begin
	{$ENDIF}
		Read(Name);
		Simulate
	{$IFNDEF PLAYERONLY}
	End;
	If(*(@Player = @Show1)
	Or*)(@Player = @Show6)Then GetSpeed
	{$ENDIF};
	Player
End;

Var
  Errors: Word;

Function RunFiles(s: PChar; Hmm: RunnerProc): Word;
Var
  f: File;
  i, Attr, Count: Word;
  DI: TSearchRec;
Label P1, P2;
Begin
  Count := 0;
  Attr := 0;
  If @Hmm <> Nil Then Attr := faArchive;
P1:
  FindFirst(s, faAnyFile-faDirectory-faVolumeID, DI);
  While DosError = 0 Do
  Begin
    FileSplit(s, Name, Nil, Nil);
    strcat(Name, DI.Name);

    If(DI.Attr And Attr) >= Attr Then
    Begin
      Inc(Count);
      If @Hmm <> Nil Then
      Begin
        If SJmp(QuickExit) = 0 Then Hmm Else Inc(Errors);

				{$IFNDEF PLAYERONLY}
				If @Player <> @Converter Then {See proc Runner}
				{$ENDIF}
          UnAllocMem(Laulu);

        LFN_SetFAttr(Name, DI.Attr And Not faArchive);
        i := IOResult;
        If i = 0 Then Goto P1;
        Goto P2
      End;
      LFN_SetFAttr(Name, DI.Attr Or faArchive);
      i := IOResult;
      If i <> 0 Then
P2:     WriteLn('NESMusa Warning: ',Name,': Can''t modify archive attribute. (Error ', i, ')')
    End;
    FindNext(DI)
  End;

  If Count=0 Then
  Begin
    FindFirst(s, faAnyFile-faVolumeID, DI);
    While DosError = 0 Do
    Begin
      Inc(Count);
      FindNext(DI)
    End;
    If s^<>#0 Then
    Begin
      Write('*** ',s,': ');
      If Count=0
        Then WriteLn('Not found.')
        Else If Count=1
          Then WriteLn('Is a directory.')
          Else WriteLn('Are directories.')
    End;
    Count := 0
  End;

  RunFiles := Count
End;

Var
  Buf: Array[0..128]Of Char;
  p, p1, p2: PChar;
  i, a, b: Word;
  m1, m2: Char;
Label J1;
Begin
  OldExit := ExitProc;
  ExitProc := SafeExit;

  HeapError := HeapFunc;

  WriteLn(Copy(Title,1,13), ' Copyright ', Copy(Title,15,255), #10);

  If SJmp(QuickExit) <> 0 Then
  Begin
    WriteLn('*** Error before reading any files.');
    Exit
  End;

  OldIMR := Port[$21];
  {$IFNDEF DPMI}
  Move(Mem[PrefixSeg-1:0], SavedMCB[0], 16);
  Move(Mem[SavedMCB[0].w+PrefixSeg:0], SavedMCB[1], 16);
  Move(Mem[0:0], SavedINT, SizeOf(SavedInt));
  {$ENDIF}

  CRTLocal.WriteStrProcAddr := WriteStr;
  FillChar(Hdr, SizeOf(Hdr), 0);

  ArgInit;

  FillWord(Patn,    SizeOf(Patn   )Div 2, 0);
  FillWord(Orders,  SizeOf(Orders )Div 2, 0);
  FillWord(PatnPtr, SizeOf(PatnPtr)Div 2, 0);

  InitLoop;

  p := strrscan(Name, '.');
  If p <> Nil Then
  Begin
    p^ := #0;
    p1 := strrscan(Name, '.');
    p^ := '.';
    If(p1 <> Nil)And(strrscan(p, '\') < p1)Then
      Move(p^, p1^, strlen(p)+1)
  End;

  If(@Player = @ListUsage)Then Begin ListUsage; Exit End;
  If(@Player = @ComprInfo)Then Begin ComprInfo; Exit End;
  If(@Player = @VersInfo )Then Begin VersInfo; Exit End;

  If AltInstru Then
  Begin
		PWord(@PChar(@NSMP1)[$20])^ := 8363;
    PWord(@PChar(@NSMP2)[$20])^ := 33452;
		m2 := #$EF;
		m1 := #$41
	End
	Else
	Begin
		PWord(@PChar(@NSMP1)[$20])^ := 13700;
		PWord(@PChar(@NSMP2)[$20])^ := 27400;
		m1 := #54;  { 128 - 128/sqrt(3) }
		m2 := #202  { 128 + 128/sqrt(3) }
	End;

	PWord(@PChar(@NSMP3)[$20])^ := 10000;

	If AltInstru2
		Then b := 166
		Else b := 209; {104.5 tai 209, jompi kumpi...}

	PChar(@NSMP3)[$40] := Chr(48 + ((b Div 10)Mod 10));
	PChar(@NSMP1)[$3D] := HC[Ord(m1)Shr 4];
	PChar(@NSMP1)[$3E] := HC[Ord(m1)And 15];
	PChar(@NSMP1)[$47] := HC[Ord(m2)Shr 4];
	PChar(@NSMP1)[$48] := HC[Ord(m2)And 15];

	For a := 0 To 8191 Do
		(PChar(@NSMP3)+$50)[a] := Chr((128-b Div 2) + Random(b));

	b := Ord(m1);
	For a := 0 To 31 Do
	Begin
		If a = 8 Then b := Ord(m2);
		(PChar(@NSMP1)+$50)[a] := Chr(b)
	End;

	For a := 0 To 63 Do
	Begin
		(PChar(@NSMP2)+$50)[    a] := Chr(a*255 Div 63);
		(PChar(@NSMP2)+$50)[127-a] := Chr(a*255 Div 63)
	End;

	a := 0;
	b := 0;
	InitArgLoop;
	Repeat
		If GetNextArg(Buf, High(Buf)) = Nil Then Break;
		p := Buf;
    If(Buf[0]<>'-')And(Buf[0]<>'/')Then
    Begin
      Inc(b);
      Inc(a, RunFiles(Buf, Nil))
    End
  Until False;

  If b=0 Then Error('*** You need to specify the filename.');
  If a=0 Then Error('*** No files.');

	{$IFNDEF PLAYERONLY}
	If @Player = @Show10 Then Goto J1;
	If @Player = @Show14 Then
	Begin
		If a>26 Then
			Error(
				'*** Too many source files specified. 26 is the'^M^J+
				'*** theoretic maximum for multiple song file.');
J1: Name[0] := #1;
		If Not Debugging Then WriteLn('Collecting source files...');
		Player
	End;

	If((@Player=@Show4)
	 Or(@Player=@Show6)
	 Or(@Player=@Show11)
	 Or(@Player=@Show13))
	And(a>1)Then
	Begin
		Write('*** ',a, ' source files specified.'^M^J+
					'*** Target file would be overwritten ');
		If a=2 Then Write('once')Else Write(a-1,' times');
		Error('.'^M^J'*** Ending.')
	End;
	{$ENDIF}

  Errors := 0;

  InitArgLoop;
  Repeat
    If GetNextArg(Buf, High(Buf)) = Nil Then Break;
    p := Buf;
		If(Buf[0]<>'-')And(Buf[0]<>'/')Then
			RunFiles(Buf, Runner)
  Until False;

	{$IFNDEF PLAYERONLY}
	If(@Player = @Show14)Or(@Player = @Show10)Then
	Begin
		Name[0] := #0;
		If SJmp(QuickExit) = 0
			Then Player
			Else Inc(Errors)
	End;
	{$ENDIF}

  If Debugging Then
  Begin
    If a=1
      Then Write('One source file handled')
      Else Write(a, ' source files handled');

    If Errors > 0 Then
    Begin
      Write(', ');
      If Errors>1
        Then Write(Errors, ' errors')
        Else Write('one error')
    End;

    WriteLn('.');

    If Errors <> a Then
    Begin
      Write('Warning: Archive attribute');
      If a-Errors = 1
        Then Write(' cleared on the'^M^J'         file that was')
        Else Write('s cleared on all'^M^J'         files that were');

      WriteLn(' succesfully handled.')
    End
  End
End.
