{Mouse functions}
{ Created in 1998-06-13 - Copyright (C) Joel Yliluoma }
Unit Mouse;

Interface

{ Palauttaa True, jos hiiri on asennettu, False jos ei.

  Esimerkkikytt: If MouseInstalled Then jes... Else virhe...

  Kertakutsu vlttmtn ohjelman alussa.
  Resetoi hiiriajurin samalla.
}
Function MouseInstalled: Boolean;

{ GetMouse* kertovat hiirikursorin koordinaatit,
  jotka ovat valituissa rajoissa, yleens
  0..639 x 0..199.

  Esimerkkikytt: PSet(GetMouseX Div 2, GetMouseY, 5);

  Toimii mys, vaikka hiirikursori ei nkyisikn.
}
Function GetMouseX: Word;
Function GetMouseY: Word;

{ *Pressed kertovat nappuloiden tilat.

  Esimerkkikytt: If LeftPressed Then WriteLn('vasenta painettu');
}
Function LeftPressed: Boolean;
Function RightPressed: Boolean;
Function MiddPressed: Boolean;

{ MouseSensetivity asettaa hiiren nopeuden. Mitn
  standardia sille, miss mrin numerot vaikuttavat,
  ei tietkseni ole olemassa.
}
Procedure MouseSensetivity(x, y: Word);

{ Asettaa rajat, joissa hiirikursori voi liikkua.
  Vaikuttaa GetMouseX ja GetMouseY -rutiinien palauttamiin arvoihin.
}
Procedure MouseWindow(x1, y1, x2, y2: Word);

{ ShowMouse rvytt hiirikursorin nkyviin,
  HideMouse piilottaa sen nytlt. Nkyviss olevan kursorin piilotus
  on jrkev tehd aina, kun list nytlle jotain, erityisesti,
  jos olet lismss nytlle jotain niille main, miss hiirikursori
  on.
  Kaksi ShowMouse -kutsua perkkin vaatii kaksi HideMouse -kutsua,
  jolloin ensimminen HideMouse ei piilota kursoria.
}
Procedure ShowMouse;
Procedure HideMouse;

Implementation

{Tss on implementation-osuus, en jaksanut sit sievent,
 koska se ei kuitenkaan olennaista ohjelmoijan kannalta.}

function mouseinstalled:boolean; assembler; asm xor ax, ax;int 33h; cmp ax,-1; je @skip; xor al,al; @skip: end;
function getmousex:word; assembler; asm mov ax,3; int 33h; mov ax,cx end;
function getmousey:word; assembler; asm mov ax,3; int 33h; mov ax,dx end;
function leftpressed:boolean; assembler; asm mov ax,3; int 33h; and bx,1; mov ax,bx end;
function rightpressed:boolean; assembler; asm mov ax,3; int 33h; and bx,2; mov ax,bx end;
function middpressed:boolean; assembler; asm xor ax, ax{; mov ax,3; int 33h; and bx,4; mov ax,bx }end;
procedure mousesensetivity(x,y:word); assembler; asm mov ax,1ah; mov bx,x; mov cx,y; xor dx,dx; int 33h end;
procedure mousewindow(x1,y1,x2,y2:word); assembler;
asm
	mov ax,7;mov cx,x1;mov dx,x2;int 33h
	mov ax,8;mov cx,y1;mov dx,y2;int 33h
end;
Procedure ShowMouse; Assembler; Asm mov ax,1; int 33h End;
Procedure HideMouse; Assembler; Asm mov ax,2; int 33h End;

End.
